/*
    IBM Confidential

    OCO Source Materials

    5724-U38, 5724-U39, 5724-U48, 5655-V17, 5655-V19, 5655-V35, 5655-V37

    © Copyright IBM Corp. 2013

    The source code for this program is not published or otherwise
    divested of its trade secrets, irrespective of what has been
    deposited with the U.S. Copyright Office.


    © Copyright 2017 UNICOM® Systems, Inc. - All Rights Reserved

    Highly Confidential Material - All Rights Reserved

    THE INFORMATION CONTAINED HEREIN CONSTITUTES AN UNPUBLISHED
    WORK OF UNICOM® SYSTEMS, INC. ALL RIGHTS RESERVED.
    NO MATERIAL FROM THIS WORK MAY BE REPRINTED,
    COPIED, OR EXTRACTED WITHOUT WRITTEN PERMISSION OF
    UNICOM® SYSTEMS, INC.  818-838-0606
 */
define(["dojo/_base/declare",
        "dojo/_base/lang",
        "dijit/_Widget",
        "dijit/_TemplatedMixin",
        "dijit/_WidgetsInTemplateMixin",
        "dojo/data/ItemFileWriteStore",
    	"dojo/store/Memory",
    	"dojo/data/ObjectStore",
        "dojo/dom-style",
        "dojox/grid/DataGrid",
        "dijit/layout/BorderContainer",
        "dijit/layout/ContentPane",
        "dojo/dom",
        "dojo/text!./templates/DsiWizardThirdPage.html",
        "dojo/i18n!./nls/widget_resources"],
        function(dDeclare,
                dLang,
                dWidget,
                dTemplatedMixin,
                dWidgetsInTemplateMixin,
                ItemFileWriteStore,
                dMemory,
                dObjectStore,
                domStyle,
                dDataGrid,
                dBorderContainer,
                dContentPane,
                dom,
                templateText,
                resources) {

return dDeclare("wizard.DsiWizardThirdPage", [dWidget,dTemplatedMixin,dWidgetsInTemplateMixin], 
{

      baseClass: "DsiWizardThirdPage",
      templateString: templateText,
      cannotGoBack: false,
      cannotGoNext: true,
      grid: null,
      
      startup: function(){   
			this.inherited(arguments);
      },

  	getDescription: function() {
  		var descriptionMessage = "";
  		require(["dojo/dom"], function(dom){
			dom.byId("pageDescrDiv").style.height="2em";
    	});
  		if (inBootStrapMode){
  			descriptionMessage = "<b>" + resources['wp3OCMDescription'] + "</b>";
		}else{
			descriptionMessage = "<b>" + resources['wp3Description'] + "</b>";
		}
		return descriptionMessage;
	},
	
	
	pageInit: function(){
	},	

	
	pageLoad: function(){
		dom.byId("centerP3Div").style.visibility="hidden";
		dom.byId("optimDirMessageDiv").style.visibility="hidden";
		if(!inBootStrapMode){
			this._getOptimDirListing();
		}else{
			this._getOCMListing();
		}
		this._setButtonsState(true);
	},
	
	isReady: function(){
		return true;
	},	
	
	_getOptimDirListing: function(){
		var uName = dsiWizardSecondPage.userNameTextBox.get("value");
    	var pWord = dsiWizardSecondPage.passwordTextBox.get("value");
    	var dbName = dsiWizardSecondPage.dbTextBox.get("value");
    	var hostName = dsiWizardSecondPage.hostTextBox.get('value');
    	var dbPort = dsiWizardSecondPage.portTextBox.get("value");
    	var customURI = dsiWizardSecondPage.customURITextBox.get("value");
    	var optimDirURL = url + "OPTIMDIR"
    	if (pageWizardMode =='edit'){
    		var id  = connectionGrid.getItem(connectionGridSelectedIndex).id;
    		optimDirURL = optimDirURL +"/"+ id;
    	}
		var vendor = "";
    	var version = "";
    	var oDirName = "";
		console.log("URL: " + optimDirURL); 
		var payload = null;
		
		if (pageWizardMode == "new"){
			vendor = dsiWizardFirstPage.vendorComboBox.get('value');
			version = dsiWizardFirstPage.versionComboBox.get('value');
		}else {
			var rD = connectionGrid.getItem(connectionGridSelectedIndex);
			vendor = rD.vendor;
			version = rD.version;
			oDirName = rD.name;
		}
    	
    	var getDstorURL = url + "TEMPLATE/" +vendor + "/"+version;
    	var payload = null;
    	var rsp = dojo.xhrGet({
            url: getDstorURL,
            sync: true,
            handleAs: "json",
            handle: function(response) {
                payload = response
            	return response;
            }
    	});
		
		
		//The datastore name is set when the finish button is clicked
		payload.datastoreType = "DIRECTORY";
		if(customURI == null || customURI.length==0){
			payload.jdbcConnectionInformation.additionalProperties.host = hostName;
			payload.jdbcConnectionInformation.additionalProperties['database.server'] = hostName;
			payload.jdbcConnectionInformation.additionalProperties['port.number'] = dbPort;
			payload.jdbcConnectionInformation.additionalProperties['org.eclipse.datatools.connectivity.db.databaseName'] = dbName; 
		}else{
			payload.jdbcConnectionInformation.additionalProperties['OPTIM_OVERRIDE_URL_KEY'] = customURI;
		}
		
		payload.userName = uName;
		payload.password = pWord;
		pagePayload = payload;
	
		var xhrArgs = {
	            url: optimDirURL,	          
	            postData: dojo.toJson(payload),	 
	            handleAs: 'json',
	            headers: POST_HEADERS,
	            load: dLang.hitch(this, "_handleGetOptimDirListing"),
	            error: dLang.hitch(this, "_handleError")
	    }
		
		dijit.byId('checkOptimDirProcessing').show();
	
		var deferred = dojo.xhrPost(xhrArgs);
	},
	
	
	_handleGetOptimDirListing: function(data){ 
		dom.byId("pageDescrDiv").style.visibility="visible";
		dom.byId("optimDirMessageDiv").style.visibility="visible";
		dom.byId("optimDirMessageDiv").innerHTML= resources['wp3DescrMessageP1'] + "<br/><br/>" + resources['wp3DescrMessageP2'] + "<br/><br/>" + resources['wp3DescrMessageP3'];
		dom.byId("centerP3Div").style.visibility="visible";
		dijit.byId('checkOptimDirProcessing').hide();
		var processedOptimDirListing = data;
		var selectedIndex = -1;
		console.log("processedOptimDirListing.items.length:" + processedOptimDirListing.items.length);
		for (var i = 0; i < processedOptimDirListing.items.length; i++) {
			if(processedOptimDirListing.items[i].classic == true ){
				processedOptimDirListing.items[i].classic = resources['classicDirText'];
			}else if (processedOptimDirListing.items[i].classic == false && processedOptimDirListing.items[i].registerable == false){
				processedOptimDirListing.items[i].classic = resources['ocmidRegisteredText'];
			} else{
				processedOptimDirListing.items[i].classic = resources['extendedDirText'];
				if (selectedIndex == -1) {
					selectedIndex = i;
				}
			}
		}
		if (selectedIndex == -1) {
			selectedIndex = 0;
		}
		
		var objectStore = new dMemory({
			data: processedOptimDirListing
		});
		var dataStore = new dObjectStore({objectStore: objectStore});
    	var layout = [
    	         	  {name: resources['directoryColumn'], field: "name", width: "20%"},
    	         	  {name: resources['descrColumn'], field: "description", width: "35%"},
    	         	  {name: resources['schemaColumn'], field: "schema", width: "20%"},
    	         	  {name: resources['statusColumn'], field: "classic", width: "25%", 
    	         		  formatter:function(status, rowIdx, cell) {
     	         			 var displayStatus = "<table style='border-style:none;'><tr><td><div class='";
	 	         			 if (status == resources['extendedDirText']) {
	 	         				displayStatus += "oneuiMsgSuccess16' /></td><td style='padding-left:5px'>"  + status + "</td></tr></table>";
	 	         			 } else if (status == resources['ocmidRegisteredText']){
	 	         				var store = cell.grid.store;
	    	         			var schema =  store.objectStore.data[rowIdx].schema;
	    	         			var optimDir =  store.objectStore.data[rowIdx].name;
	    	         			var dialogMsg = dojo.string.substitute(resources['ocmDeleteMessage'], [optimDir]);
	    	         			var titleMsg = resources['ocmDeleteTitle'];
	 	         				displayStatus += "oneuiMsgInfo16' /></td><td style='padding-left:5px'>"  + 
 	         					status + "</td> <td align='right' style='padding-left:10px'>" + 
 	         					"<button data-dojo-type='dijit/form/Button' type='button' id='fixButton'" +
 	         					" style='font-size:10px' data-dojo-attach-point='fixButton' onclick='handleDeleteOCMEntry(\"" + schema + "\", \"" + dialogMsg + "\", \"" + titleMsg +
 	         					"\");'>" + resources['changeStatus'] + "</button></td></tr></table>";
	 	         			 }else{
	 	         				displayStatus += "oneuiMsgError16' /></td><td style='padding-left:5px'>" + status + "</td></tr></table>";
	 	         			 }
	 	         			 return displayStatus;
     	         		  } 
    	         	  }
    	         	];
    	this.grid = new dDataGrid({
    		name: 'optimDirGrid',
    		store: dataStore,
    		query: { name: "*" },
    		structure: layout,
    		selectionMode: 'single',
    		sortInfo: '1',
    		style: "width:99%; border: none;"
    	});
    	this.centerPane.set('content', this.grid);
    	
    	this.grid.startup();
    	this.grid.on("RowClick", dLang.hitch(this, "_handleOnRowClick"));
    	this.grid.on("CellMouseOver", dLang.hitch(this, "_handleOnCellMouseOver"));
    	this.grid.on("CellMouseOut", dLang.hitch(this, "_handleOnCellMouseOut"));
    	this._fetchComplete(selectedIndex);
	},
	
	_getOCMListing: function(){
		var uName = dsiWizardSecondPage.userNameTextBox.get("value");
    	var pWord = dsiWizardSecondPage.passwordTextBox.get("value");
    	var dbName = dsiWizardSecondPage.dbTextBox.get("value");
    	var hostName = dsiWizardSecondPage.hostTextBox.get('value');
    	var dbPort = dsiWizardSecondPage.portTextBox.get("value");
    	var customURI = dsiWizardSecondPage.customURITextBox.get("value");
		var ocmURL = url + "OCMDIR"
		var vendor = "";
    	var version = "";
		console.log("URL: " + ocmURL); 
		var payload = null;
		
		if (pageWizardMode == "new"){
			vendor = dsiWizardFirstPage.vendorComboBox.get('value');
			version = dsiWizardFirstPage.versionComboBox.get('value');
		}else {
			var rD = connectionGrid.getItem(connectionGridSelectedIndex);
			vendor = rD.vendor;
			version = rD.version;
		}
    	
    	var getDstorURL = url + "TEMPLATE/" +vendor + "/"+version;
    	var payload = null;
    	var rsp = dojo.xhrGet({
            url: getDstorURL,
            sync: true,
            handleAs: "json",
            handle: function(response) {
                payload = response
            	return response;
            }
    	});
		
		
		payload.datastoreName = "OCMCONN";
		payload.datastoreType = "STARTUP"; 
		if(customURI == null || customURI.length==0){
			payload.jdbcConnectionInformation.additionalProperties.host = hostName;
			payload.jdbcConnectionInformation.additionalProperties['database.server'] = hostName;
			payload.jdbcConnectionInformation.additionalProperties['port.number'] = dbPort;
			payload.jdbcConnectionInformation.additionalProperties['org.eclipse.datatools.connectivity.db.databaseName'] = dbName;
		}else{
			payload.jdbcConnectionInformation.additionalProperties['OPTIM_OVERRIDE_URL_KEY'] = customURI;
		} 

		payload.userName = uName; 
		payload.password = pWord;
		pagePayload = payload;
	
		var xhrArgs = {
	            url: ocmURL,	          
	            postData: dojo.toJson(payload),	 
	            handleAs: 'json',
	            headers: POST_HEADERS,
	            load: dLang.hitch(this, "_handleGetOCMListing"),
	            error: dLang.hitch(this, "_handleError")
	    }
		dijit.byId('schemaSearchProcessing').show();
		var deferred = dojo.xhrPost(xhrArgs);
	},

	
	_handleGetOCMListing: function(data){
		dom.byId("pageDescrDiv").style.visibility="visible";
		dom.byId("optimDirMessageDiv").style.visibility="visible";
		dom.byId("optimDirMessageDiv").innerHTML= resources['wp3OCMDescrMessageP1'] + "<br/><br/>" + resources['wp3OCMDescrMessageP2'] + "<br/><br/>" + resources['wp3OCMDescrMessageP3'];
		dom.byId("centerP3Div").style.visibility="visible";
		dijit.byId('schemaSearchProcessing').hide();
		var processedOptimDirListing = data;
		var selectedIndex = -1;
		console.log("processedOptimDirListing.items.length:" + processedOptimDirListing.items.length);
		for (var i = 0; i < processedOptimDirListing.items.length; i++) {
			if(processedOptimDirListing.items[i].classic == true){
				processedOptimDirListing.items[i].classic = resources['classicDirText'];
			}
			else{
				processedOptimDirListing.items[i].classic = resources['extendedDirText'];
				if (selectedIndex == -1) {
					selectedIndex = i;
				}
			}
		}
		if (selectedIndex == -1) {
			selectedIndex = 0;
		}
		
		var objectStore = new dMemory({
			data: processedOptimDirListing
		});
		var dataStore = new dObjectStore({objectStore: objectStore});
    	var layout = [
    	         	  {name: resources['ocmColumn'], field: "schema", width: "100%"}
    	         	  ];
    	this.grid = new dDataGrid({
    		name: 'optimDirGrid',
    		store: dataStore,
    		query: { name: "*" },
    		structure: layout,
    		selectionMode: 'single',
    		sortInfo: '1',
    		style: "width:99%; border: none;"
    	});
    	this.centerPane.set('content', this.grid);
    	
    	this.grid.startup();
    	this.grid.on("RowClick", dLang.hitch(this, "_handleOnRowClick"));
    	this.grid.on("CellMouseOver", dLang.hitch(this, "_handleOnCellMouseOver"));
    	this.grid.on("CellMouseOut", dLang.hitch(this, "_handleOnCellMouseOut"));
    	this._fetchComplete(selectedIndex);
	},
	
	
	
	_handleOnCellMouseOver: function(e) {
		if (e.cell.field == "classic") {
			var item = e.grid.getItem(e.rowIndex);
	        var classicValue = e.grid.store.getValue(item, e.cell.field);
	        var dirValue = e.grid.store.getValue(item, "name");
	        var msg = dirValue + " ";
	        if (classicValue == resources['extendedDirText']) {
	        	msg += resources['readyMessageSuffix'];
	        } else if(classicValue == resources['ocmidRegisteredText']) {
	        	msg += resources['ocmIdRegisteredMessageSuffix'];
	        }else{
	        	msg += resources['notReadyMessageSuffix'];
	        }
	        dijit.showTooltip(msg, e.cellNode);
		}
	},
	
	_handleOnCellMouseOut: function(e) {
		dijit.hideTooltip(e.cellNode); 
	},
	
	
	_handleError: function(error){
		dijit.byId('checkOptimDirProcessing').hide();
		var errMsg = resources['optimDirErrorPrefix'] + " ";
		switch(error.status){
			case 404: 
				errMsg += resources['optimDirNotFoundErrorSuffix'];
				break;
			default:
				errMsg += resources['dueToErrorText'] + " " + error.xhr.statusText + resources['optimDirErrorSuffix'];
		}
		console.log(error.xhr.status+" "+error.xhr.statusText);
		this._populateResultMessage("oneuiMsgError22", errMsg, "optimDirMessageDiv");
		dom.byId("pageDescrDiv").style.visibility="hidden";
		dom.byId("optimDirMessageDiv").style.visibility="visible";
		//this._updateWizardButtons();
		this._setButtonsState(true);
	},
	
	_updateWizardButtons: function() {
		var wizard = this.getParent().getParent().getParent(); //->StackContainer->ContentPane(center)->BorderContainer(wizard)
		wizard._checkButtons();
	},
	
	_fetchComplete: function(selectedIndex){
		this.grid.selection.setSelected(selectedIndex,true);
		this.grid.scrollToRow(selectedIndex);
		var clickEvent = document.createEvent("MouseEvent");
		clickEvent.rowIndex = selectedIndex;	
		this._handleOnRowClick(clickEvent);			
	},
	
	_handleOnRowClick: function(event){
		var rowData = this.grid.getItem(event.rowIndex);
        if(rowData.classic == resources['extendedDirText']){
        	this._updateWizardButtons();
        	this._setButtonsState(false);
        }
        else{
        	this._setButtonsState(true);
        }        
	},
	
	_setButtonsState: function(state){
		wizard = this.getParent().getParent().getParent(); //->StackContainer->ContentPane(center)->BorderContainer(wizard)
		if(state){
			wizard.finishButton.set("disabled",state);
			//wizard.cancelButton.set("disabled",state);
		}
		else{
			wizard.finishButton.set("disabled",state);
			//wizard.cancelButton.set("disabled",state);
		}
		
	},
	
	_populateResultMessage: function(imgClass, msg, div) {
    	var result = this._formatResultTable(imgClass, msg);
		require(["dojo/dom"], function(dom){
			dom.byId(div).innerHTML = result;
    	});
    },
  
    _formatResultTable: function(imgClass, msg) {
    	var resultTable = "<table style='border-style:none'><tr><td><div class='" + imgClass + "' /></td><td style='padding-left:5px'>" + msg + "</td></tr></table>"; 
    	return resultTable; 
    },
  
	postCreate: function() {
		this.inherited(arguments);   	  
	},
      
	resize: function() {
		this.inherited(arguments);
		this.mainContainer.resize();
	}

});
});

function handleDeleteOCMEntry(schema, dialogMessage, titleMessage) {
	var dialog = new dijit.Dialog({
        title: titleMessage,
        style: "width: 300px"
    });
    
    dojo.create('div', {id: "formDialog"}, dialog.containerNode);
    
    dojo.create('div', {id: "div1_1"}, "formDialog");
    dojo.style(dojo.byId("div1_1"), "float", "left");
    dojo.style(dojo.byId("div1_1"), "class", "dijitDialogPaneContentArea");
    dojo.style(dojo.byId("div1_1"), "margin-bottom", "10px");
    dojo.place("<label>" + dialogMessage + "</label>", "div1_1");
    
    dojo.create('div', {id: "div1_2"}, "formDialog");
    dojo.style(dojo.byId("div1_2"), "float", "right");
    dojo.style(dojo.byId("div1_2"), "class", "dijitDialogPaneActionBar");
    dojo.style(dojo.byId("div1_2"), "margin-top", "10px");
    dojo.style(dojo.byId("div1_2"), "margin-bottom", "20px");

    var cancelButton = new dijit.form.Button({
        label: "No",
        onClick: function(){
        	dialog.destroyRecursive()
            dojo.destroy(dialog);
        }
     });

    var okButton = new dijit.form.Button({
        label: "Yes",
        onClick : function(){
        	deleteOCMEntry(schema);
        	dialog.destroyRecursive();
            dojo.destroy(dialog);
        }
     });
    dojo.create(okButton.domNode,{}, "div1_2");
    dojo.create(cancelButton.domNode,{}, "div1_2");
    dialog.show();
}

function deleteOCMEntry(schema) {
	var payload = getPayloadForDeleteOCM();
	var postUrl = url + "FORCE_DELETE" + "/" + schema;
	console.log("Forcibly delete OCM entry. URL = " + postUrl);
	var xhrArgs = {
		url: postUrl,
		postData: dojo.toJson(payload),	 
		handleAs: 'json',
		headers: POST_HEADERS,
		load: this.dsiWizardThirdPage.pageLoad(),
		error: function(error){
	        alert("Error: Unable to change status.");
	      }
	}
	//Call delete on the server and UI if successful
	var deferred = dojo.xhrPost(xhrArgs);
}

function getPayloadForDeleteOCM() {
	var uName = dsiWizardSecondPage.userNameTextBox.get("value");
	var pWord = dsiWizardSecondPage.passwordTextBox.get("value");
	var dbName = dsiWizardSecondPage.dbTextBox.get("value");
	var hostName = dsiWizardSecondPage.hostTextBox.get('value');
	var dbPort = dsiWizardSecondPage.portTextBox.get("value");
	var customURI = dsiWizardSecondPage.customURITextBox.get("value");
	
	var vendor = "";
	var version = "";
	var oDirName = "";
	var payload = null;
	
	if (pageWizardMode == "new"){
		vendor = dsiWizardFirstPage.vendorComboBox.get('value');
		version = dsiWizardFirstPage.versionComboBox.get('value');
	}else {
		var rD = connectionGrid.getItem(connectionGridSelectedIndex);
		vendor = rD.vendor;
		version = rD.version;
		oDirName = rD.name;
	}
	
	var getDstorURL = url + "TEMPLATE/" +vendor + "/"+version;
	var payload = null;
	var rsp = dojo.xhrGet({
        url: getDstorURL,
        sync: true,
        handleAs: "json",
        handle: function(response) {
            payload = response
        	return response;
        }
	});
	
	
	//The datastore name is set when the finish button is clicked
	payload.datastoreType = "DIRECTORY";
	if(customURI == null || customURI.length==0){
		payload.jdbcConnectionInformation.additionalProperties.host = hostName;
		payload.jdbcConnectionInformation.additionalProperties['database.server'] = hostName;
		payload.jdbcConnectionInformation.additionalProperties['port.number'] = dbPort;
		payload.jdbcConnectionInformation.additionalProperties['org.eclipse.datatools.connectivity.db.databaseName'] = dbName; 
	}else{
		payload.jdbcConnectionInformation.additionalProperties['OPTIM_OVERRIDE_URL_KEY'] = customURI;
	}
	
	payload.userName = uName;
	payload.password = pWord;
	return payload;
}